/*
Cracker Class for the program into2000

*/

class cracker
	{
  protected:
	int x, y, col;
	int rad;
	float ang, vel;
	float xvel, yvel;

	int now_x, now_y;

	char* buf;
	int cur_time;
	int memalloc;
	int onscreen;

	void set_onscreen()
		{
		onscreen = (now_x<0 || now_x>639 || now_y<0 || now_y>479)? 0 : 1;
		}

  public:
	void start_life(int x1, int y1, int col1, int rad1, float ang1, float vel1)
		{
		x = now_x = x1; y = now_y = y1;
		col = col1; rad = rad1;
		ang = ang1; vel = vel1;
		xvel = vel*cos(ang); yvel=vel*sin(ang);
		memalloc = 1;			//memory will be allocated in this func
		cur_time = 0;
		set_onscreen();

		//store the image of cracker
		int imgsize = imagesize(0, 0, rad*2, rad*2);

		char* buftemp = new char[imgsize+1]; assert (buftemp);
		getimage(0, 0, rad*2, rad*2, buftemp);	//store background

		setcolor(col);
		setfillstyle(SOLID_FILL, col);

		if (random(10)<7)
			fillellipse(rad, rad, rad, rad);       //draw ellipse
		else
			{
			int poly[8];
			poly[0]=0; poly[1]=rad;
			poly[2]=rad; poly[3]=0;
			poly[4]=rad*2; poly[5]=rad;
			poly[6]=rad; poly[7]=rad*2;
			fillpoly(4, poly);
			}

		buf = new char[imgsize+1]; assert (buf);
		getimage(0, 0, rad*2, rad*2, buf);		//store image of cracker

		putimage(0,0,buftemp,COPY_PUT);			//restore background

		delete buftemp;
		}

	void draw()
		{
		if (onscreen && memalloc)
			putimage(now_x-rad, now_y-rad, buf, XOR_PUT);
		}

	void move()
		{					//calculate new position
		cur_time++;

		float calc_time = cur_time * TIME_GAP;
		float dx = xvel * calc_time;
		float dy = yvel * calc_time - 0.5 * GRAVITY * calc_time * calc_time;

		now_x = x + PIXPERMET * dx;
		now_y = y - PIXPERMET * dy;

		set_onscreen();
		}

	void end_life()
		{
		if (memalloc)
			{
			delete buf;
			memalloc = 0;
			}
		}

	int get_x() 		{ return now_x; }
	int get_y()			{ return now_y; }
	float get_ang()	{ return ang; }
	float get_vel()	{ return vel; }

	int should_live() { return ((now_x<0 || now_x>639 || now_y>479)? 0:1); }

	};
