#include <TIME.H>
#include <STDLIB.H>
#include <ASSERT.H>
#include <GRAPHICS.H>
#include <STDIO.H>
#include <CONIO.H>
#include <DOS.H>
#include <MATH.H>

#define TIME_GAP 0.020
#define GRAVITY 10
#define PIXPERMET 50
#define PI 3.14159
#define MAX_CRACKERS 50
#define MIN_CRACKERS 20
#define DELAYINMS 11
const int MAX_VELO = 12;
const int MIN_VELO = 5;
const int MAX_RAD = 4;
const int MIN_RAD = 1;

#include "CLASS.H"

void disp_text();
void disp_crackers();
int start_new_cracker(int, int, float, float);
void end_cracker(int);
void explode_cracker(int);
int num_of_crackers();

cracker* crackers[MAX_CRACKERS];
char used[MAX_CRACKERS];

void main()
	{
	if (registerfarbgidriver(EGAVGA_driver_far) < 0)
		{
		printf("Error registering egavga driver");
		return;
		}
	if (registerfarbgifont(triplex_font_far) < 0)
		{
		printf("Error registering font driver");
		return;
		}


	int gd=VGA, gm=VGAHI;
	initgraph(&gd, &gm, "");
	int errorcode = graphresult();
	if (errorcode != grOk)  /* an error occurred */
		{
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);             /* return with error code */
		}

	char text[30];
	//setusercharsize(2, 1, 4, 1);
	settextstyle(TRIPLEX_FONT, 0, 0);
	setcolor(RED);
	sprintf(text, "A Millenium Of Joy");
	outtextxy(150, 100, text);
	sprintf(text, "Wishing You");
	outtextxy(200, 50, text);

	disp_text();
	disp_crackers();

	getch();

	closegraph();
	}


void disp_text()
	{
	char text[50];
	char image1[3000];

	sprintf(text, "This is 2000!");

	settextstyle(TRIPLEX_FONT, 0, 0);
	setcolor(1);
	outtext(text);
	getimage(0,8,208,34, (void*) image1);

	int incx = 5;

	for (int x=0; x<=300; )
		{
		delay(25);
		putimage(x,8,image1,XOR_PUT);
		x+=incx;
		putimage(x,8,image1,XOR_PUT);
		}

	}

void disp_crackers()
	{
	register int t;
	int count1=50;
	int count2=100;

	//initialize used array
	for (t=0; t<MAX_CRACKERS; t++)
		used[t] = 0;

	randomize();

	start_new_cracker(100, 400, 0.45*PI, MAX_VELO);
	start_new_cracker(540, 400, 0.60*PI, MAX_VELO-5);

	for (t=0; t<MAX_CRACKERS; t++)
		if (used[t]) crackers[t]->draw();

	while (1) //for (i=0; i<=100; i++)
		{
		if (kbhit()) break;

		count2--;
		if (count2==0)
			{
			setpalette(1+random(15), random(64) );
			count2=random(25);
			}

		for (t=0; t<MAX_CRACKERS; t++)      //erase
			if (used[t]) crackers[t]->draw();

		for (t=0; t<MAX_CRACKERS; t++)
			if (used[t]) crackers[t]->move();

		for (t=0; t<MAX_CRACKERS; t++)      //check whether any have gone out
			if (used[t])                     //of screen, then kill them
				if (crackers[t]->should_live() == 0)			//should die
					{
					count1--;
					end_cracker(t);
					if (count1==0) 			// on a random chance, generate a new
						{                                              //one
						start_new_cracker(100+random(440), 400,
							(45+random(90)) * (PI/180),
									MIN_VELO + random(MAX_VELO-MIN_VELO) );
						count1=random(80);
						}
					}

		for (t=0; t<MAX_CRACKERS; t++)				// explode randomly
			if (used[t] && random(100) == 0 )
				explode_cracker(t);

		if ( (t=num_of_crackers()) <= MIN_CRACKERS)  // if very less crackers,
			for (t = MIN_CRACKERS-t; t>=0; t--)       // generate some
				start_new_cracker(100+random(440), 400,
											(45+random(90)) * (PI/180),
											MIN_VELO + random(MAX_VELO-MIN_VELO) );

		for (t=0; t<MAX_CRACKERS; t++)			//draw crackers
			if (used[t]) crackers[t]->draw();

		delay(DELAYINMS);
		}

	// kill all crackers
	for (t=0; t<MAX_CRACKERS; t++)
		if (used[t]) end_cracker(t);
	}

int start_new_cracker(int start_x, int start_y, float angle, float velo)
	{
	int k;

	for ( k=0; k<MAX_CRACKERS; k++)
		if (used[k]==0) break;
	if (k==MAX_CRACKERS) return -1;			// no space left for new crackers

	crackers[k] = new cracker;
	assert(crackers[k]);			//should not be null pointer
	used[k] = 1;

	crackers[k]->start_life(start_x,start_y, random(16),
			MIN_RAD + random(MAX_RAD-MIN_RAD), angle, velo);

	return k;

	}

void end_cracker(int cracker_num)
	{
	if (used[cracker_num] == 0) return;

	crackers[cracker_num]->end_life();
	delete crackers[cracker_num];
	used[cracker_num] = 0;

	}

void explode_cracker(int cracker_num)
	{
	int x = crackers[cracker_num]->get_x();
	int y = crackers[cracker_num]->get_y();
	float v = crackers[cracker_num]->get_vel();
	end_cracker(cracker_num);

	sound(1000);
	delay(5);
	nosound();

	for (int j=0; j<=5; j++)			//make 6 new objects
		start_new_cracker(x, y, j*PI/3.0, 4*v/5);

	}

int num_of_crackers()
	{
	int to_return=0;
	for (int i=0; i<MAX_CRACKERS; i++)
		to_return += used[i];
	return to_return;
	}
